/* -------------------------------------------------------------------------------------------------- */
/* To retrieve user preference from local storage and display it			                          */
/* To store/overwrite user preference in local storage                                                */
/* Control options include						                                                 	  */
/* 1. Enable/Disable notification (SWYM and DSSWYM)	                                                  */
/* 2. Notification duration							                                                  */
/* 3. Notification type						                                                 		  */
/* 4. Varying SWYM URL as per release						                                          */
/* 5. Reset the notificaiton extension, so that user can reset the application in case of breakdown   */
/* -------------------------------------------------------------------------------------------------- */

	$(document).ready(function(){		

		$("#userFeedbackForm").hide();				// By default hide the user feedback form
		
		$('#userFeedback').click(function(){		// On click, unhide the google user feedback form and hide if the check box is unchecked.
			if (this.checked) {
				$("#userFeedbackForm").show();
			}else {
				$("#userFeedbackForm").hide();
			}
		}); 		
	
		// To get already stored user preference of DSSWYM/3DSWYM and set the preference during options load/displayed to user.
		chrome.storage.sync.get('dsSwymNotification', function (val) {
			//console.log("Debug: Value for Ds Swym Notitication :"+val.dsSwymNotification); 
			if(val.dsSwymNotification == "yes"){	
				//console.log("Debug: Ds Swym Notitication is enabled"); // Debug Check point
				document.getElementById("dsNotify").checked=true;				
				chrome.storage.sync.get('dsSwymNotificationClose', function (val){
					//console.log("Debug: The closing time of DSSWYM Notification is stored in storage as: '+val.dsSwymNotificationClose+' Milli seconds"); // Debug Check point
					switch (val.dsSwymNotificationClose){
						case '1000': 
							$("#DSSwymDropDown").val('1000');
							break;
						case '2000': 
							$("#DSSwymDropDown").val('2000');
							break;
						case '3000': 
							$("#DSSwymDropDown").val('3000');
							break;						
						case '4000': 
							$("#DSSwymDropDown").val('4000');
							break;
						case '5000': 
							$("#DSSwymDropDown").val('5000');
							break;
						case '6000': 
							$("#DSSwymDropDown").val('6000');
							break;
						case '7000': 
							$("#DSSwymDropDown").val('7000');
							break;
						case '8000': 
							$("#DSSwymDropDown").val('8000');
							break;
						case '9000': 
							$("#DSSwymDropDown").val('9000');
							break;
						case '10000': 
							$("#DSSwymDropDown").val('10000');
							break;
						case '15000': 
							$("#DSSwymDropDown").val('15000');
							break;
						case 'manual': 
							$("#DSSwymDropDown").val('manual');
						default:
							break;
					}						
				});	
				
				chrome.storage.sync.get('dsSwymUrl', function (val){
					var dsSwymUrl= val.dsSwymUrl; // ***********This variable exis10000ce need to be evaluated
					$('#currentDsSwymUrl').text('Current URL: '+ dsSwymUrl);
					//console.log("Debug: The URL for DSSWYM is: "+dsSwymUrl);    // Debug Check point
					if(dsSwymUrl =="" ||dsSwymUrl == undefined ){
						$('#currentDsSwymUrl').text('Current URL: '+ "Not defined yet");
					}
				});		
				
				chrome.storage.sync.get('notificaitonTypeDSSwym', function (val){
					var notificaitonTypeDSSwym= val.notificaitonTypeDSSwym; // ***********This variable exis10000ce need to be evaluated
					if(notificaitonTypeDSSwym =="basic"){
						$('input[type=radio][name=notificaitonTypeDSSwym]')[0].checked = true;
					}else{
						$('input[type=radio][name=notificaitonTypeDSSwym]')[1].checked = true;
					}
					//console.log("Debug: The type of notification for DSWYM is : "+notificaitonTypeDSSwym); // Debug Check point
				});
				
			} else {
				document.getElementById("dsNotify").checked=false;
				$('#dsSwymOptions').slideUp();
			}
		});		

		chrome.storage.sync.get('d3SwymNotification', function (val) {
			//console.log("Debug: value for 3d swym notification: "+val.d3SwymNotification);
			if(val.d3SwymNotification == "yes"){
				//console.log("Debug: 3DSwym Notitication is enabled"); // Debug Check point
				document.getElementById("3dNotify").checked=true;
				
				chrome.storage.sync.get('d3SwymNotificationClose', function (val) {
					//console.log("Debug: the value in the storage: "+val.d3SwymNotificationClose); // Debug Check point
					switch (val.d3SwymNotificationClose){
						case '1000': 
							$("#SwymDropDown").val('1000');
							break;
						case '2000': 
							$("#SwymDropDown").val('2000');
							break;
						case '3000': 
							$("#SwymDropDown").val('3000');
							break;						
						case '4000': 
							$("#SwymDropDown").val('4000');
							break;
						case '5000': 
							$("#SwymDropDown").val('5000');
							break;
						case '6000': 
							$("#SwymDropDown").val('6000');
							break;
						case '7000': 
							$("#SwymDropDown").val('7000');
							break;
						case '8000': 
							$("#SwymDropDown").val('8000');
							break;
						case '9000': 
							$("#SwymDropDown").val('9000');
							break;
						case '10000': 
							$("#SwymDropDown").val('10000');
							break;
						case '15000': 
							$("#DSSwymDropDown").val('15000');
							break;							
						case 'manual': 
							$("#SwymDropDown").val('manual');
						default:
							break;
					}	
				});		

				chrome.storage.sync.get('d3SwymUrl', function (val){ 
					var d3SwymUrl= val.d3SwymUrl; 	// ***********This variable existence need to be evaluated
					$('#current3dSwymUrl').text('Current URL: '+ d3SwymUrl);
					if(d3SwymUrl =="" ||d3SwymUrl == undefined ){
						$('#current3dSwymUrl').text('Current URL: '+ "Not defined yet");
					}
					//console.log("Debug: The URL for 3DSWYM is: "+d3SwymUrl);  // Debug Check point
				});		

				chrome.storage.sync.get('notificaitonType3dswym', function (val){
					var notificaitonType3dswym= val.notificaitonType3dswym; // ***********This variable existene need to be evaluated
					if(notificaitonType3dswym =="basic"){
						$('input[type=radio][name=notificaitonType3dswym]')[0].checked = true;
					}else{
						$('input[type=radio][name=notificaitonType3dswym]')[1].checked = true;
					}
					//console.log("Debug: The type of notification for 3DSWYM is : "+notificaitonType3dswym); // Debug Check point
				});		
				
			} else {
				document.getElementById("3dNotify").checked=false;
				$('#3dSwymOptions').slideUp();
			}			
		});				

			/* -------------------------------------------------------------------------------------- */
			/* On checking the DSSWYM/ 3DSWYM notificaiton,							 				  */
			/* 1. Notification is enabled i.e. webservice call initiated for every 30s			  	  */
			/* 2. Set the notificaiton closing time, get user set value or default value set 		  */
			/* 3. Set type of notification user should get i.e. Image or basic notification 		  */
			/* -------------------------------------------------------------------------------------- */
			$('#dsNotify').click(function(){
				if($(this).is(':checked')){
					$('#dsSwymOptions').slideDown();
					chrome.storage.sync.set({'dsSwymNotification': "yes"}, function () {
						//console.log("Debug: DsSwym desktop notification enabled"); // Debug Check point
					});	
					chrome.storage.sync.set({'dsSwymNotificationClose': $('#DSSwymDropDown option:selected').val()}, function () {
						//console.log("Debug: DsSwym notification close is time dependent: " +  $('#DSSwymDropDown option:selected').val()); // Debug Check point
					});		
					chrome.storage.sync.set({'notificaitonTypeDSSwym': $('input[type=radio][name=notificaitonTypeDSSwym]:checked').val()}, function () {
						//console.log("Debug: notificaitonTypeDSSwym is stored as : "+ $('input[type=radio][name=notificaitonTypeDSSwym]:checked').val()); // Debug Check point
					});					
					alert('Check the Option "Continue running apps in background after Google chrome is closed" under settings to avail Desktop Notification service');	
				}else { 				 	
					$('#dsSwymOptions').slideUp();
					chrome.storage.sync.set({'dsSwymNotification': "no"}, function () {
						//console.log("Debug: DsSwym desktop notification disabled");  // Debug Check point
					});
				}
			});			
				
			$('#3dNotify').click(function(){
				if($(this).is(':checked')){
					$('#3dSwymOptions').slideDown();
					chrome.storage.sync.set({'d3SwymNotification': "yes"}, function () {
						//console.log("Debug: 3DSwym desktop notification enabled"); // Debug Check point
					});	
					chrome.storage.sync.set({'d3SwymNotificationClose': $('#SwymDropDown option:selected').val()}, function () {
						//console.log("Debug: 3DSwym notification close is time dependent: " +  $('#SwymDropDown option:selected').val()); // Debug Check point
					});								
					chrome.storage.sync.set({'notificaitonType3dswym': $('input[type=radio][name=notificaitonType3dswym]:checked').val()}, function () {
						//console.log("Debug: NotificaitonType3dswym stored as : "+ $('input[type=radio][name=notificaitonType3dswym]:checked').val()); // Debug Check point
					});
					alert("User is requested to run chrome is background to enable Desktop Notification service");
				}else {  			 		
					$('#3dSwymOptions').slideUp();
					chrome.storage.sync.set({'d3SwymNotification': "no"}, function () {
						//console.log("Debug: 3dSwym desktop notification disabled"); // Debug Check point
					});
				}	
			});						

			// Notification duration, change in preference by user is recorded to local storage
			$('#DSSwymDropDown').change(function(){
					chrome.storage.sync.set({'dsSwymNotificationClose': $('#DSSwymDropDown option:selected').val()}, function () {
						//console.log("Debug: DsSwym notification close is time dependent: " +  $('#DSSwymDropDown option:selected').val()); // Debug Check point
					});						
			});
			
			$('#SwymDropDown').change(function(){
					chrome.storage.sync.set({'d3SwymNotificationClose': $('#SwymDropDown option:selected').val()}, function () {
						//console.log("Debug: Swym notification close is time dependent: " +  $('#SwymDropDown option:selected').val()); // Debug Check point
					});						
			});

			// Notification type, change in preference by user is recorded in local storage
			$('input[type=radio][name=notificaitonTypeDSSwym]').change(function() {
				chrome.storage.sync.set({'notificaitonTypeDSSwym': $('input[type=radio][name=notificaitonTypeDSSwym]:checked').val()}, function () {
						//console.log("Debug: notificaitonTypeDSSwym is stored as : "+ $('input[type=radio][name=notificaitonTypeDSSwym]:checked').val()); // Debug Check point
				});
			});

			$('input[type=radio][name=notificaitonType3dswym]').change(function() {
				chrome.storage.sync.set({'notificaitonType3dswym': $('input[type=radio][name=notificaitonType3dswym]:checked').val()}, function () {
						//console.log("Debug: notificaitonType3dswym stored as : "+ $('input[type=radio][name=notificaitonType3dswym]:checked').val()); // Debug Check point
				});
			});		
			
			// On Update button click, URL input by user is recorded to local storage	
			$('#bUpdateDsSwymUrl').click(function(){
				if($('#dsSwymUrl').val() != ""){		
					chrome.storage.sync.set({'dsSwymUrl': $('#dsSwymUrl').val()}, function () {
						//console.log("Debug: Ds Swym URL: "+ $('#dsSwymUrl').val()); // Debug Check point
					}); 
					$('#currentDsSwymUrl').text('Current URL: '+ dsSwymUrl);
				} 
				else{
					alert("Field is empty");
				}
			});
			
			$('#bUpdate3dSwymUrl').click(function(){
				if($('#d3SwymUrl').val() != ""){			
					chrome.storage.sync.set({'d3SwymUrl': $('#d3SwymUrl').val()}, function () {
						//console.log("Debug: 3DSwym URL: "+ $('#d3SwymUrl').val()); // Debug Check point
					});
					$('#current3dSwymUrl').text('Current URL: '+ d3SwymUrl);
				} 
				else{
					alert("Field is empty");
				}
			});

			// On click will clear the local storage value, It is a flush of preference and a new start from beginning
			$("#clearStorage").click(function(){
				chrome.storage.sync.clear(function(){
					//console.log("Debug: Storage cleared"); // Debug Check point
				});
			});		
			
	});		